-----------------------------------------------------------------------------

AloftTag = { }
AloftTagMethods = { }
AloftTagDirectAccessData = { isBoss = true, level = true, name = true }
AloftTagData = { }

-----------------------------------------------------------------------------

AloftTagMethods.bracket = function(aloftData, value) 
	if value and value ~= "" then 
		return "("..value..")"
	else
		return nil
	end
end

-----------------------------------------------------------------------------

function AloftTag:ProcessTag(tag, offset, dataTable, priorResult)

	local s,e = tag:find(":", offset)
	local quotedS,quotedE = tag:find("\"[^\"]*\"", offset)

	if quotedS and quotedS < (s or #tag) then
		if quotedE == #tag then
			if offset == 1 then
				return string.format("%s", tag:sub(quotedS, quotedE))
			else
				return string.format("%s and %s", priorResult, tag:sub(quotedS, quotedE))
			end
		elseif tag:sub(quotedE+1, quotedE+1) == ":"	then
			if offset == 1 then
				return AloftTag:ProcessTag(tag, quotedE+2, dataTable, string.format("%s", tag:sub(quotedS, quotedE)))
			else
				return AloftTag:ProcessTag(tag, quotedE+2, dataTable, string.format("%s and %s", priorResult, tag:sub(quotedS, quotedE)))
			end
		else
			Aloft:Print("Tag error near quotes")
			dataTable["ERROR"] = true
			return "\"\""
		end
	else
		local identifier = tag:sub(offset,s and s-1 or nil)
		local data = AloftTagData[identifier]
		if data then
			dataTable[data[1]] = data[2]
		end
		if AloftTagDirectAccessData[identifier] then
			if s then
				return AloftTag:ProcessTag(tag, e+1, dataTable, string.format("aloftData.%s", identifier))
			else
				return string.format("aloftData.%s", identifier)
			end
		elseif AloftTagMethods[identifier] then
			if s then
				if offset == 1 then
					return AloftTag:ProcessTag(tag, e+1, dataTable, string.format("AloftTagMethods.%s(aloftData)", identifier))
				else
					return AloftTag:ProcessTag(tag, e+1, dataTable, string.format("AloftTagMethods.%s(aloftData, %s)", identifier, priorResult))
				end
			else
				if offset == 1 then
					return string.format("AloftTagMethods.%s(aloftData)", tag:sub(offset))
				else
					return string.format("AloftTagMethods.%s(aloftData, %s)", tag:sub(offset), priorResult)
				end
			end
		else
			Aloft:Print("Invalid tag: "..identifier)
			dataTable["ERROR"] = true
			return "\"\""
		end
	end
end


-- Returns a function to create the tag, and a table of required values
function AloftTag:CreateTagFunction(tag)
	local functionString = "return function(aloftData) return "
	local dataTable = { }

	offset = 1
	repeat
		local s, e = tag:find("%[[^[]+%]", offset)
		if offset ~= 1 then
			functionString = functionString..".."
		end
		if s then
			if s ~= offset then
				functionString = functionString.."\""..tag:sub(offset, s-1).."\".."
			end
			functionString = string.format("%s(%s or \"\")", functionString, AloftTag:ProcessTag(tag:sub(s+1, e-1), 1, dataTable, ""))
			offset = e+1
			if offset > #tag then
				offset = nil
			end
		else
			functionString = functionString.."\""..tag:sub(offset).."\""
			offset = nil
		end
	until offset == nil

	if dataTable["ERROR"] then
		functionString = "return function() return \"Tag Error\" end"
		dataTable["ERROR"] = nil
	else
		functionString = functionString.." end"
	end

	return loadstring(functionString)(), dataTable
end

-----------------------------------------------------------------------------
